Index: java/net/deterlab/abac/Query.java
===================================================================
--- java/net/deterlab/abac/Query.java	(revision a1a9a471dec6bf5a579f4b1121bd7eda35432970)
+++ java/net/deterlab/abac/Query.java	(revision 461edbacbc68d23da4dd80313c3fe043e700b2e8)
@@ -149,5 +149,5 @@
 	 * Return a collection of outgoing edges under the search direction's
 	 * interpretation.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex from which the edges come
 	 * @return a collection of outgoing edges under the search direction's
@@ -158,5 +158,5 @@
 	 * Return a collection of incoming edges under the search direction's
 	 * interpretation.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex into which the edges come
 	 * @return a collection of outgoing edges under the search direction's
@@ -167,5 +167,5 @@
 	 * Return the source of this edge under the search direction's
 	 * interpretation.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the source of this edge under the search direction's
@@ -176,5 +176,5 @@
 	 * Return the destination of this edge under the search direction's
 	 * interpretation.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the destination of this edge under the search direction's
@@ -196,5 +196,5 @@
 	 * Return a collection of outgoing edges; outgoing is defined by the
 	 * graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex from which the edges come
 	 * @return a collection of outgoing edges
@@ -206,5 +206,5 @@
 	 * Return a collection of incoming edges; incoming is defined by the
 	 * graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex into which the edges come
 	 * @return a collection of outgoing edges
@@ -215,5 +215,5 @@
 	/**
 	 * Return the source of this edge as defined by the underlying graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the source of this edge 
@@ -225,5 +225,5 @@
 	 * Return the destination of this edge as defined by the underlying
 	 * graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the destination of this edge 
@@ -246,5 +246,5 @@
 	 * Return a collection of outgoing edges; outgoing is reversed with
 	 * respect to the graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex from which the edges come
 	 * @return a collection of outgoing edges
@@ -256,5 +256,5 @@
 	 * Return a collection of incoming edges; incoming is reversed with
 	 * respect to the graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param v a V, the vertex into which the edges come
 	 * @return a collection of outgoing edges
@@ -266,5 +266,5 @@
 	 * Return the source of this edge in the reverse of the underlying
 	 * graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the source of this edge 
@@ -276,5 +276,5 @@
 	 * Return the destination of this edge in the reverse of the underlying
 	 * graph.
-	 * @param g the Graph<V, E> being traversed
+	 * @param g the Graph&lt;V, E&gt; being traversed
 	 * @param e an E, the edge being considered
 	 * @return the destination of this edge 
@@ -323,7 +323,7 @@
      * @param src the Role to start the search from 
      * @param dest the Role to find a path to
-     * @param path a Graph<Role, Credential> in which the result path is
+     * @param path a Graph&lt;Role, Credential&gt; in which the result path is
      * returned
-     * @param dir a bfsSearchDirection<Role, Credential> that defines direction
+     * @param dir a bfsSearchDirection&lt;Role, Credential&gt; that defines direction
      * of search and side effects
      * @return true if the path is found